
Dynace Object-Oriented Extension to C
===============================

### Dynace is a portable, open-source extension to the C language that adds the following capabilities to standard C:

* full object-oriented capabilities including
  * classes, instances, methods, & generic functions
  * encapsulation
  * polymorphism
  * (multiple) inheritance
* fully meta-class based (like Smalltalk or CLOS)
* dynamic binding and dispatching through generic functions (like CLOS)
* garbage collection
* cooperative threads (also supports native threads)
* full class library

### Dynace:

* written in standard C
* includes over 300 pages of documentation (https://blakemcbride.github.io/Dynace/manual/Dynace.pdf)
* step-by-step tutorials
* using classes involves no new syntax elements to standard C
* easily added to existing C code

### Dynace is portable across:

* 16, 32 & 64 bit environments
* Linux
* Mac OS X
* Windows (all versions)
* BSD
* Solaris / OpenIndiana
* Plan 9
* Minix
* ARM (cross-build)

The main home for this system is:  https://github.com/blakemcbride/Dynace

Dynace is production quality and has been used in commercial environments for more than ten years.

Dynace was written to solve perceived problems with C++ as outlined in the user manual.

Dynace is released under the BSD 2-Clause license.

System overview is at:  docs/ORIENT.txt

Build instructions are at:  docs/BUILD.txt


