/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0




#define	CLASS	BufferedTempFile_c
#define	ivType	BufferedTempFile_iv_t

#include "generics.h"

object	BufferedTempFile_c;


#line 48 "BufferedTempFile.c"
typedef struct  _BufferedTempFile_iv_t  {
	char * iBuffer;
	int iBufSize;
	int iCurrentOffset;
	object iTmpFile;
	int iSize;
}	BufferedTempFile_iv_t;


#line 44 "BufferedTempFile.d"
#include <string.h> 

#ifndef max 
#define max(a,b) ((a) > (b) ? (a) : (b)) 
#endif 


#line 49 "BufferedTempFile.d"
#ifndef min 
#define min(a,b) ((a) < (b) ? (a) : (b)) 
#endif 


#line 53 "BufferedTempFile.d"
PMETHOD objrtn BufferedTempFile_initVars(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	iv->iBufSize = 1024; 
	iv->iBuffer = (char*)calloc(1, iv->iBufSize + 1); 
	return self; 
} 

cmeth objrtn BufferedTempFile_cm_gOpenTempFile(object self)
{ 
	return BufferedTempFile_initVars(oSuper(BufferedTempFile_c, gNew, self)(self)); 
} 

imeth objrtn BufferedTempFile_im_gGCDispose(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	free(iv->iBuffer); 
	return oSuper(BufferedTempFile_c, gDispose, self)(self); 
} 

imeth objrtn BufferedTempFile_im_gDispose(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	if (iv->iTmpFile) 
		gDispose(iv->iTmpFile); 
	return gGCDispose(self); 
} 

imeth int BufferedTempFile_im_gRead(object self, char *buf, unsigned n)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	int bytesRead = min(n, iv->iBufSize - iv->iCurrentOffset); 

	if (iv->iTmpFile) 
		return gRead(iv->iTmpFile, buf, n); 
	else 
	{ 
		memcpy(buf, iv->iBuffer + iv->iCurrentOffset, bytesRead); 
		iv->iCurrentOffset += bytesRead; 
		return bytesRead; 
	} 
} 

PMETHOD void createTempFile(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	iv->iTmpFile = gOpenTempFile(File); 
	gWrite(self, iv->iBuffer, iv->iSize); 
	gFlush(self); 
} 

imeth int BufferedTempFile_im_gWrite(object self, char *buf, unsigned n)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	if (iv->iTmpFile) 
		return gWrite(iv->iTmpFile, buf, n); 
	else 
	{ 
		if (n + iv->iCurrentOffset > iv->iBufSize) 
		{ 
			createTempFile(self); 
			return gWrite(self, buf, n); 
		} 
		else 
		{ 
			memcpy(iv->iBuffer + iv->iCurrentOffset, buf, n); 
			iv->iCurrentOffset += n; 
			iv->iSize = max(iv->iCurrentOffset, iv->iSize); 
			return n; 
		} 
	} 
} 

imeth char * BufferedTempFile_im_gGets(object self, char *buf, int sz)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	char *tmpBuffer; 

	if (iv->iTmpFile) 
		return gGets(iv->iTmpFile, buf, sz); 
	else 
	{ 



		tmpBuffer = strstr(iv->iBuffer + iv->iCurrentOffset, "\n"); 

		if (tmpBuffer == NULL) 
		{ 
			gRead(self, buf, sz - 1); 
			buf[sz - 1] = 0x00; 
		} 
		else if (tmpBuffer - iv->iBuffer + iv->iCurrentOffset <= sz - 1) 
		{ 
			gRead(self, buf, tmpBuffer - iv->iBuffer + iv->iCurrentOffset + 1); 
			buf[tmpBuffer - iv->iBuffer + iv->iCurrentOffset] = 0x00; 
		} 
		else 
		{ 
			gRead(self, buf, sz - 1); 
			buf[sz - 1] = 0x00; 
		} 

		return buf; 
	} 
} 

imeth long BufferedTempFile_im_gAdvance(object self, long n)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	if (iv->iTmpFile) 
		return gAdvance(iv->iTmpFile, n); 
	else 
		if (n > iv->iSize - iv->iCurrentOffset) 
		return 0; 
	else 
	{ 
		iv->iCurrentOffset += n; 
		return n; 
	} 
} 

imeth long BufferedTempFile_im_gRetreat(object self, long n)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	int bytesRetreated = min(iv->iCurrentOffset, n); 

	if (iv->iTmpFile) 
		return gRetreat(iv->iTmpFile, n); 
	else 
		if (n > iv->iCurrentOffset) 
		return 0; 
	else 
	{ 
		iv->iCurrentOffset -= n; 
		return n; 
	} 
} 

imeth long BufferedTempFile_im_gSeek(object self, long n)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	if (iv->iTmpFile) 
		return gSeek(iv->iTmpFile, n); 
	else 
	{ 
		iv->iCurrentOffset = min(n, iv->iBufSize); 
		return min(n, iv->iBufSize); 
	} 
} 

imeth long BufferedTempFile_im_gPosition(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	return iv->iTmpFile ? gPosition(iv->iTmpFile) : iv->iCurrentOffset; 
} 

imeth long BufferedTempFile_im_gLength(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	return iv->iTmpFile ? gLength(iv->iTmpFile) : iv->iSize; 
} 

imeth char * BufferedTempFile_im_gName(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	if (iv->iTmpFile) 
		return gName(iv->iTmpFile); 
	else 
	{ 



		createTempFile(self); 
		return gName(self); 
	} 
} 

imeth int BufferedTempFile_im_gEndOfStream(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	return iv->iTmpFile ? gEndOfStream(iv->iTmpFile) : iv->iCurrentOffset != iv->iSize; 
} 

imeth void * BufferedTempFile_im_gPointerValue(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	if (iv->iTmpFile) 
		return gPointerValue(iv->iTmpFile); 
	else 
	{ 



		createTempFile(self); 
		return gPointerValue(self); 
	} 
} 

imeth int BufferedTempFile_im_gFlush(object self)
{ BufferedTempFile_iv_t *iv = GetIVs(BufferedTempFile, self);
	return iv->iTmpFile ? gFlush(iv->iTmpFile) : iv->iSize; 
} 


#line 263 "BufferedTempFile.c"

objrtn	BufferedTempFile_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (BufferedTempFile_c) {
		LEAVECRITICALSECTION(cs);
		return BufferedTempFile_c;
	}
	INHIBIT_THREADER;
	BufferedTempFile_c = gNewClass(Class, "BufferedTempFile", sizeof(BufferedTempFile_iv_t), 0, END);
	cMethodFor(BufferedTempFile, gOpenTempFile, BufferedTempFile_cm_gOpenTempFile);
	iMethodFor(BufferedTempFile, gFlush, BufferedTempFile_im_gFlush);
	iMethodFor(BufferedTempFile, gRetreat, BufferedTempFile_im_gRetreat);
	iMethodFor(BufferedTempFile, gPosition, BufferedTempFile_im_gPosition);
	iMethodFor(BufferedTempFile, gLength, BufferedTempFile_im_gLength);
	iMethodFor(BufferedTempFile, gWrite, BufferedTempFile_im_gWrite);
	iMethodFor(BufferedTempFile, gEndOfStream, BufferedTempFile_im_gEndOfStream);
	iMethodFor(BufferedTempFile, gSeek, BufferedTempFile_im_gSeek);
	iMethodFor(BufferedTempFile, gPointerValue, BufferedTempFile_im_gPointerValue);
	iMethodFor(BufferedTempFile, gAdvance, BufferedTempFile_im_gAdvance);
	iMethodFor(BufferedTempFile, gDispose, BufferedTempFile_im_gDispose);
	iMethodFor(BufferedTempFile, gName, BufferedTempFile_im_gName);
	iMethodFor(BufferedTempFile, gGets, BufferedTempFile_im_gGets);
	iMethodFor(BufferedTempFile, gGCDispose, BufferedTempFile_im_gGCDispose);
	iMethodFor(BufferedTempFile, gDeepDispose, BufferedTempFile_im_gDispose);
	iMethodFor(BufferedTempFile, gRead, BufferedTempFile_im_gRead);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return BufferedTempFile_c;
}



