/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0




#define	CLASS	IntegerDictionary_c
#define	ivType	IntegerDictionary_iv_t

#include "generics.h"

object	IntegerDictionary_c;


#line 38 "IntegerDictionary.d"
#include "set1.h" 



#define LTYPE 4 

static gLookup_t Lookup; 

imeth objrtn IntegerDictionary_im_gAddInt(object self, int key, object value)
{ 
	ChkArgNul(value, 3); 
	return Lookup(self, (object) &key, HT_ADD, 0, LTYPE, value); 
} 

imeth objrtn IntegerDictionary_im_gFindValueInt(object self, int key)
{ 
	object x; 

	x = Lookup(self, (object) &key, HT_FIND, 0, LTYPE, NULL); 
	return x ? gValue(x) : x; 
} 

imeth objrtn IntegerDictionary_im_gFindInt(object self, int key)
{ 
	return Lookup(self, (object) &key, HT_FIND, 0, LTYPE, NULL); 
} 

imeth objrtn IntegerDictionary_im_gChangeValueWithInt(object self, int key, object val)
{ 
	object x; 
	ChkArgNul(val, 3); 
	x = Lookup(self, (object) &key, HT_FIND, 0, LTYPE, NULL); 
	return x ? gChangeValue(x, val) : x; 
} 

imeth objrtn IntegerDictionary_im_gFindAddInt(object self, int key, object value)
{ 
	ChkArgNul(value, 3); 
	return Lookup(self, (object) &key, HT_FINDADD, 0, LTYPE, value); 
} 

imeth objrtn IntegerDictionary_im_gDispose(object self)
{ 
	return gDispose1(self); 
} 

imeth objrtn IntegerDictionary_im_gDisposeAllNodes(object self)
{ 
	return gDisposeAllNodes1(self); 
} 

imeth objrtn IntegerDictionary_im_gRemoveInt(object self, int key)
{ 
	return Lookup(self, (object) &key, HT_DELETE, 1, LTYPE, NULL); 
} 

imeth objrtn IntegerDictionary_im_gDeepDisposeInt(object self, int key)
{ 
	return Lookup(self, (object) &key, HT_DELETE, 2, LTYPE, NULL); 
} 

static void init_class(void) 
{ 
	Lookup = imcPointer(Set, gLookup); 
} 

#line 115 "IntegerDictionary.c"

objrtn	IntegerDictionary_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (IntegerDictionary_c) {
		LEAVECRITICALSECTION(cs);
		return IntegerDictionary_c;
	}
	INHIBIT_THREADER;
	Set_initialize();
	if (IntegerDictionary_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return IntegerDictionary_c;
	}
	IntegerDictionary_c = gNewClass(Class, "IntegerDictionary", 0, 0, Set, END);
	iMethodFor(IntegerDictionary, gChangeValueWithInt, IntegerDictionary_im_gChangeValueWithInt);
	iMethodFor(IntegerDictionary, gDeepDisposeInt, IntegerDictionary_im_gDeepDisposeInt);
	iMethodFor(IntegerDictionary, gDisposeInt, IntegerDictionary_im_gDeepDisposeInt);
	iMethodFor(IntegerDictionary, gDisposeAllNodes, IntegerDictionary_im_gDisposeAllNodes);
	iMethodFor(IntegerDictionary, gRemoveInt, IntegerDictionary_im_gRemoveInt);
	iMethodFor(IntegerDictionary, gFindInt, IntegerDictionary_im_gFindInt);
	iMethodFor(IntegerDictionary, gFindValueInt, IntegerDictionary_im_gFindValueInt);
	iMethodFor(IntegerDictionary, gDispose, IntegerDictionary_im_gDispose);
	iMethodFor(IntegerDictionary, gAddInt, IntegerDictionary_im_gAddInt);
	iMethodFor(IntegerDictionary, gFindAddInt, IntegerDictionary_im_gFindAddInt);

	init_class();

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return IntegerDictionary_c;
}



