/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 33 "LongArray.d"
#include "array1.h" 

#define	CLASS	LongArray_c
#define	ivType	LongArray_iv_t

#include "generics.h"

object	LongArray_c;


#line 40 "LongArray.d"
#define TYPE long 


static gIndex_t _index; 


cvmeth objrtn LongArray_cvm_vNew(object self, va_list _rest_)
{ 
	unsigned rank = va_arg(_rest_, unsigned);

#line 48 "LongArray.d"
	static gNewArray_t cnew = NULL; 
	MAKE_REST(rank); 

	if (!cnew) 
		cnew = cmcPointer(Array, gNewArray); 
	return cnew(self, AT_LONG, rank, _rest_); 
} 

#line 70 "LongArray.c"

static	objrtn	LongArray_cfm_vNew(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_cvm_vNew(self, _rest_);
}



#line 56 "LongArray.d"
ivmeth char LongArray_ivm_vCharValue(object self, va_list _rest_)
{ 
	MAKE_REST(self); 
	return (char) *((TYPE *) _index(self, _rest_)); 
} 

#line 88 "LongArray.c"

static	char	LongArray_ifm_vCharValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vCharValue(self, _rest_);
}



#line 62 "LongArray.d"
ivmeth short LongArray_ivm_vShortValue(object self, va_list _rest_)
{ 
	MAKE_REST(self); 
	return (short) *((TYPE *) _index(self, _rest_)); 
} 

#line 106 "LongArray.c"

static	short	LongArray_ifm_vShortValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vShortValue(self, _rest_);
}



#line 68 "LongArray.d"
ivmeth unsigned short LongArray_ivm_vUnsignedShortValue(object self, va_list _rest_)
{ 
	MAKE_REST(self); 
	return (unsigned short) *((TYPE *) _index(self, _rest_)); 
} 

#line 124 "LongArray.c"

static	unsigned short	LongArray_ifm_vUnsignedShortValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vUnsignedShortValue(self, _rest_);
}



#line 74 "LongArray.d"
ivmeth long LongArray_ivm_vLongValue(object self, va_list _rest_)
{ 
	MAKE_REST(self); 
	return (long) *((TYPE *) _index(self, _rest_)); 
} 

#line 142 "LongArray.c"

static	long	LongArray_ifm_vLongValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vLongValue(self, _rest_);
}



#line 80 "LongArray.d"
ivmeth double LongArray_ivm_vDoubleValue(object self, va_list _rest_)
{ 
	MAKE_REST(self); 
	return (double) *((TYPE *) _index(self, _rest_)); 
} 

#line 160 "LongArray.c"

static	double	LongArray_ifm_vDoubleValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vDoubleValue(self, _rest_);
}



#line 86 "LongArray.d"
ivmeth objrtn LongArray_ivm_vChangeValue(object self, va_list _rest_)
{ object val = va_arg(_rest_, object);
	MAKE_REST(val); 
	ChkArg(val, 2); 
	*((TYPE *) _index(self, _rest_)) = gLongValue(val); 
	return self; 
} 

#line 180 "LongArray.c"

static	objrtn	LongArray_ifm_vChangeValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vChangeValue(self, _rest_);
}



#line 94 "LongArray.d"
ivmeth objrtn LongArray_ivm_vChangeCharValue(object self, va_list _rest_)
{ int val = va_arg(_rest_, int);
	MAKE_REST(val); 
	*((TYPE *) _index(self, _rest_)) = (TYPE) val; 
	return self; 
} 

#line 199 "LongArray.c"

static	objrtn	LongArray_ifm_vChangeCharValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vChangeCharValue(self, _rest_);
}



#line 101 "LongArray.d"
ivmeth objrtn LongArray_ivm_vChangeShortValue(object self, va_list _rest_)
{ int val = va_arg(_rest_, int);
	MAKE_REST(val); 
	*((TYPE *) _index(self, _rest_)) = (TYPE) val; 
	return self; 
} 

#line 218 "LongArray.c"

static	objrtn	LongArray_ifm_vChangeShortValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vChangeShortValue(self, _rest_);
}



#line 108 "LongArray.d"
ivmeth objrtn LongArray_ivm_vChangeUShortValue(object self, va_list _rest_)
{ unsigned val = va_arg(_rest_, unsigned);
	MAKE_REST(val); 
	*((TYPE *) _index(self, _rest_)) = (TYPE) val; 
	return self; 
} 

#line 237 "LongArray.c"

static	objrtn	LongArray_ifm_vChangeUShortValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vChangeUShortValue(self, _rest_);
}



#line 115 "LongArray.d"
ivmeth objrtn LongArray_ivm_vChangeLongValue(object self, va_list _rest_)
{ long val = va_arg(_rest_, long);
	MAKE_REST(val); 
	*((TYPE *) _index(self, _rest_)) = (TYPE) val; 
	return self; 
} 

#line 256 "LongArray.c"

static	objrtn	LongArray_ifm_vChangeLongValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vChangeLongValue(self, _rest_);
}



#line 122 "LongArray.d"
ivmeth objrtn LongArray_ivm_vChangeDoubleValue(object self, va_list _rest_)
{ double val = va_arg(_rest_, double);
	MAKE_REST(val); 
	*((TYPE *) _index(self, _rest_)) = (TYPE) val; 
	return self; 
} 

#line 275 "LongArray.c"

static	objrtn	LongArray_ifm_vChangeDoubleValue(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return LongArray_ivm_vChangeDoubleValue(self, _rest_);
}


#line 129 "LongArray.d"
static void class_init(void) 
{ 
	_index = imcPointer(Array, gIndex); 
} 

#line 291 "LongArray.c"

objrtn	LongArray_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (LongArray_c) {
		LEAVECRITICALSECTION(cs);
		return LongArray_c;
	}
	INHIBIT_THREADER;
	NumberArray_initialize();
	if (LongArray_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return LongArray_c;
	}
	LongArray_c = gNewClass(Class, "LongArray", 0, 0, NumberArray, END);
	cvMethodFor(LongArray, vNew, LongArray_cvm_vNew, LongArray_cfm_vNew);
	ivMethodFor(LongArray, vCharValue, LongArray_ivm_vCharValue, LongArray_ifm_vCharValue);
	ivMethodFor(LongArray, vChangeUShortValue, LongArray_ivm_vChangeUShortValue, LongArray_ifm_vChangeUShortValue);
	ivMethodFor(LongArray, vChangeValue, LongArray_ivm_vChangeValue, LongArray_ifm_vChangeValue);
	ivMethodFor(LongArray, vLongValue, LongArray_ivm_vLongValue, LongArray_ifm_vLongValue);
	ivMethodFor(LongArray, vChangeCharValue, LongArray_ivm_vChangeCharValue, LongArray_ifm_vChangeCharValue);
	ivMethodFor(LongArray, vUnsignedShortValue, LongArray_ivm_vUnsignedShortValue, LongArray_ifm_vUnsignedShortValue);
	ivMethodFor(LongArray, vChangeDoubleValue, LongArray_ivm_vChangeDoubleValue, LongArray_ifm_vChangeDoubleValue);
	ivMethodFor(LongArray, vDoubleValue, LongArray_ivm_vDoubleValue, LongArray_ifm_vDoubleValue);
	ivMethodFor(LongArray, vChangeShortValue, LongArray_ivm_vChangeShortValue, LongArray_ifm_vChangeShortValue);
	ivMethodFor(LongArray, vChangeLongValue, LongArray_ivm_vChangeLongValue, LongArray_ifm_vChangeLongValue);
	ivMethodFor(LongArray, vShortValue, LongArray_ivm_vShortValue, LongArray_ifm_vShortValue);

	class_init();

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return LongArray_c;
}



