/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 32 "LowFile.d"
#ifdef _MSC_VER 
#if _MSC_VER > 1200 
#define _CRT_SECURE_NO_DEPRECATE 
#define _POSIX_ 
#endif 


#line 37 "LowFile.d"
#endif 


#line 40 "LowFile.d"
#include <fcntl.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#if !defined(unix) && !defined(__APPLE__) && !defined(__minix) 
#include <io.h> 
#include <sys/locking.h> 
#include <errno.h> 
#endif 


#line 49 "LowFile.d"
#if defined(sparc) || defined(unix) || defined(__APPLE__) || defined(PLAN9) || defined(__minix) 
#include <unistd.h> 
#define tell(h) lseek(h, 0L, SEEK_CUR) 
#endif 


#define	CLASS	LowFile_c
#define	ivType	LowFile_iv_t

#include "generics.h"

object	LowFile_c;


#line 77 "LowFile.c"
typedef struct  _LowFile_iv_t  {
	object iName;
	int iHandle;
}	LowFile_iv_t;


#line 84 "LowFile.c"
typedef struct  _LowFile_cv_t  {
	ifun cMoreHandles;
}	LowFile_cv_t;

static	LowFile_cv_t	*LowFile_cv;



#line 65 "LowFile.d"
cmeth objrtn LowFile_cm_gNew(object self)
{ 
	return gShouldNotImplement(self, "gNew"); 
} 

PMETHOD objrtn LowFile_initVars(object self, char *name, int handle)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	iv->iName = gNewWithStr(String, name); 
	iv->iHandle = handle; 
	return self; 
} 

cmeth objrtn LowFile_cm_gOpenLowFile(object self, char *name, int oflag, int pmode)
{ 
	int handle; 

	if (IsObj((object) name)) 
		name = gStringValue((object) name); 
#ifdef PLAN9 
	handle = open(name, oflag); 
#else 


#line 86 "LowFile.d"
	handle = open(name, oflag, pmode); 
#endif 


#line 88 "LowFile.d"
	if (handle == -1) { 
		gMoreHandles(LowFile); 
#ifdef PLAN9 
		handle = open(name, oflag); 
#else 


#line 93 "LowFile.d"
		handle = open(name, oflag, pmode); 
#endif 


#line 95 "LowFile.d"
	} 
	if (handle == -1) 
		return NULL; 
	return LowFile_initVars(oSuper(LowFile_c, gNew, self)(self), name, handle); 
} 

imeth objrtn LowFile_im_gGCDispose(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	close(iv->iHandle); 
	return oSuper(LowFile_c, gDispose, self)(self); 
} 

imeth objrtn LowFile_im_gDispose(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	gDispose(iv->iName); 
	return gGCDispose(self); 
} 

imeth int LowFile_im_gRead(object self, char *buf, unsigned n)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	return read(iv->iHandle, buf, n); 
} 

imeth int LowFile_im_gWrite(object self, char *buf, unsigned n)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	return write(iv->iHandle, buf, n); 
} 

imeth char * LowFile_im_gGets(object self, char *buf, int sz)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	int h = iv->iHandle; 
	int i, r; 
	char c; 

	if (sz <= 0) 
		return NULL; 
	if (sz-- == 1) { 
		*buf = '\0'; 
		return buf; 
	} 
	for (i=0 ; i < sz ; ) { 
		r = read(h, &c, 1); 
		if (!r && !i || r < 0) 
			return NULL; 
		if (!r) 
			break; 
		buf[i++] = c; 
		if (c == '\n') 
			break; 
	} 
	buf[i] = '\0'; 
	return buf; 
} 

imeth long LowFile_im_gAdvance(object self, long n)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	int h = iv->iHandle; 
	long p = tell(h); 
	long r = lseek(h, n, SEEK_CUR); 
	return r >= 0L ? r-p : 0L; 
} 

imeth long LowFile_im_gRetreat(object self, long n)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	int h = iv->iHandle; 
	long p = tell(h); 
	long r = lseek(h, -n, SEEK_CUR); 
	return r >= 0L ? p-r : 0L; 
} 

imeth long LowFile_im_gSeek(object self, long n)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	long r = lseek(iv->iHandle, n, SEEK_SET); 
	return r; 
} 

imeth long LowFile_im_gPosition(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	return tell(iv->iHandle); 
} 

imeth long LowFile_im_gLength(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
#ifdef PLAN9 
		return tell(iv->iHandle); 
#else 

#line 181 "LowFile.d"
		struct stat sb; 
	int r; 

	r = fstat(iv->iHandle, &sb); 
	return r ? -1L : sb.st_size; 
#endif 

#line 187 "LowFile.d"
	} 

imeth char * LowFile_im_gName(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	return gStringValue(iv->iName); 
} 

imeth int LowFile_im_gEndOfStream(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
#if !defined(unix) && !defined(__APPLE__) && !defined(PLAN9) && !defined(__minix) 
		return eof(iv->iHandle); 
#else 

#line 199 "LowFile.d"
		gShouldNotImplement(self, "EndOfStream"); 
	iv->iHandle = iv->iHandle; 
	return 0; 
#endif 

#line 203 "LowFile.d"
	} 

imeth int LowFile_im_gFileHandle(object self)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
	return iv->iHandle; 
} 

cmeth ifun LowFile_cm_gSetMoreHandles(object self, ifun fun)
{ 
	ifun pfun = LowFile_cv->cMoreHandles; 
	LowFile_cv->cMoreHandles = fun; 
	return pfun; 
} 

cmeth objrtn LowFile_cm_gMoreHandles(object self)
{ 
	if (LowFile_cv->cMoreHandles) 
		LowFile_cv->cMoreHandles(); 
	return self; 
} 

imeth int LowFile_im_gLock(object self, unsigned long start, unsigned long len, int wait)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
#ifdef PLAN9 
		gShouldNotImplement(self, "gLock"); 
	return 0; 
#else 

#line 230 "LowFile.d"
#if !defined(unix) && !defined(__APPLE__) && !defined(__minix) 
		int r; 

	_lseek(iv->iHandle, start, SEEK_SET); 
	do { 
		r = _locking(iv->iHandle, wait ? _LK_LOCK : _LK_NBLCK, len); 
#line 240 "LowFile.d"
#ifndef _WIN32 
		} while (wait && r && (errno == EACCES || errno == EDEADLOCK)); 
#else 

#line 243 "LowFile.d"
	} 

#line 243 "LowFile.d"
while (wait && r); 
#endif 


#line 245 "LowFile.d"
return r; 
#else 


#line 247 "LowFile.d"
struct flock fs; 

fs.l_type = F_WRLCK; 
fs.l_whence = SEEK_SET; 
fs.l_start = start; 
fs.l_len = len; 
return -1 == fcntl(iv->iHandle, wait ? F_SETLKW : F_SETLK, &fs) ? -1 : 0; 
#endif 


#line 255 "LowFile.d"
#endif 


#line 256 "LowFile.d"
} 

imeth int LowFile_im_gUnLock(object self, unsigned long start, unsigned long len)
{ LowFile_iv_t *iv = GetIVs(LowFile, self);
#ifdef PLAN9 
		gShouldNotImplement(self, "gUnLock"); 
	return 0; 
#else 

#line 264 "LowFile.d"
#if !defined(unix) && !defined(__APPLE__) && !defined(__minix) 
		_lseek(iv->iHandle, start, SEEK_SET); 
	return _locking(iv->iHandle, _LK_UNLCK, len); 
#else 

#line 268 "LowFile.d"
		struct flock fs; 

	fs.l_type = F_UNLCK; 
	fs.l_whence = SEEK_SET; 
	fs.l_start = start; 
	fs.l_len = len; 
	return -1 == fcntl(iv->iHandle, F_SETLK, &fs) ? -1 : 0; 
#endif 

#line 276 "LowFile.d"
#endif 

#line 277 "LowFile.d"
	} 


#line 353 "LowFile.c"

objrtn	LowFile_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (LowFile_c) {
		LEAVECRITICALSECTION(cs);
		return LowFile_c;
	}
	INHIBIT_THREADER;
	Stream_initialize();
	if (LowFile_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return LowFile_c;
	}
	LowFile_c = gNewClass(Class, "LowFile", sizeof(LowFile_iv_t), sizeof(LowFile_cv_t), Stream, END);
	cMethodFor(LowFile, gMoreHandles, LowFile_cm_gMoreHandles);
	cMethodFor(LowFile, gNew, LowFile_cm_gNew);
	cMethodFor(LowFile, gSetMoreHandles, LowFile_cm_gSetMoreHandles);
	cMethodFor(LowFile, gOpenLowFile, LowFile_cm_gOpenLowFile);
	iMethodFor(LowFile, gRetreat, LowFile_im_gRetreat);
	iMethodFor(LowFile, gPosition, LowFile_im_gPosition);
	iMethodFor(LowFile, gLength, LowFile_im_gLength);
	iMethodFor(LowFile, gWrite, LowFile_im_gWrite);
	iMethodFor(LowFile, gEndOfStream, LowFile_im_gEndOfStream);
	iMethodFor(LowFile, gSeek, LowFile_im_gSeek);
	iMethodFor(LowFile, gUnLock, LowFile_im_gUnLock);
	iMethodFor(LowFile, gAdvance, LowFile_im_gAdvance);
	iMethodFor(LowFile, gDispose, LowFile_im_gDispose);
	iMethodFor(LowFile, gName, LowFile_im_gName);
	iMethodFor(LowFile, gGets, LowFile_im_gGets);
	iMethodFor(LowFile, gGCDispose, LowFile_im_gGCDispose);
	iMethodFor(LowFile, gDeepDispose, LowFile_im_gDispose);
	iMethodFor(LowFile, gFileHandle, LowFile_im_gFileHandle);
	iMethodFor(LowFile, gRead, LowFile_im_gRead);
	iMethodFor(LowFile, gLock, LowFile_im_gLock);

	LowFile_cv = GetCVs(LowFile);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return LowFile_c;
}



