/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0




#define	CLASS	ObjectAssociation_c
#define	ivType	ObjectAssociation_iv_t

#include "generics.h"

object	ObjectAssociation_c;


#line 48 "ObjectAssociation.c"
typedef struct  _ObjectAssociation_iv_t  {
	object iValue;
}	ObjectAssociation_iv_t;



#line 37 "ObjectAssociation.d"
cmeth objrtn ObjectAssociation_cm_gNewWithObjObj(object self, object key, object val)
{ 
	object assoc; 
	ivType *iv; 

	ChkArgNul(key, 2); 
	ChkArgNul(val, 3); 
	assoc = oSuper(ObjectAssociation_c, gNewWithObj, self)(self, key); 
	iv = ivPtr(assoc); 
	iv->iValue = val; 
	return assoc; 
} 

imeth objrtn ObjectAssociation_im_gDeepCopy(object self)
{ ObjectAssociation_iv_t *iv = GetIVs(ObjectAssociation, self);
	object nobj; 

	nobj = oSuper(ObjectAssociation_c, gDeepCopy, self)(self); 
	ivPtr(nobj)->iValue = iv->iValue ? gDeepCopy(iv->iValue) : NULL; 
	return nobj; 
} 

imeth objrtn ObjectAssociation_im_gValue(object self)
{ ObjectAssociation_iv_t *iv = GetIVs(ObjectAssociation, self);
	return iv->iValue; 
} 

imeth objrtn ObjectAssociation_im_gChangeValue(object self, object value)
{ ObjectAssociation_iv_t *iv = GetIVs(ObjectAssociation, self);
	object ret; 
	ChkArgNul(value, 2); 
	ret = iv->iValue; 
	iv->iValue = value; 
	return ret; 
} 

imeth objrtn ObjectAssociation_im_gDeepDispose(object self)
{ ObjectAssociation_iv_t *iv = GetIVs(ObjectAssociation, self);
	if (iv->iValue) 
		gDeepDispose(iv->iValue); 
	return oSuper(ObjectAssociation_c, gDeepDispose, self)(self); 
} 

imeth objrtn ObjectAssociation_im_gStringRepValue(object self)
{ ObjectAssociation_iv_t *iv = GetIVs(ObjectAssociation, self);
	object s, k, v; 

	k = gKey(self); 
	k = k ? gStringRepValue(k) : gNewWithStr(String,"(null)"); 
	v = iv->iValue ? gStringRepValue(iv->iValue) : gNewWithStr(String,"(null)"); 
	s = vBuild(String, "( ", k, ", ", v, " )", NULL); 
	gDispose(k); 
	gDispose(v); 
	return s; 
} 


#line 113 "ObjectAssociation.c"

objrtn	ObjectAssociation_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (ObjectAssociation_c) {
		LEAVECRITICALSECTION(cs);
		return ObjectAssociation_c;
	}
	INHIBIT_THREADER;
	LookupKey_initialize();
	if (ObjectAssociation_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return ObjectAssociation_c;
	}
	ObjectAssociation_c = gNewClass(Class, "ObjectAssociation", sizeof(ObjectAssociation_iv_t), 0, LookupKey, END);
	cMethodFor(ObjectAssociation, gNewWithObjObj, ObjectAssociation_cm_gNewWithObjObj);
	iMethodFor(ObjectAssociation, gValue, ObjectAssociation_im_gValue);
	iMethodFor(ObjectAssociation, gStringRepValue, ObjectAssociation_im_gStringRepValue);
	iMethodFor(ObjectAssociation, gChangeValue, ObjectAssociation_im_gChangeValue);
	iMethodFor(ObjectAssociation, gDeepDispose, ObjectAssociation_im_gDeepDispose);
	iMethodFor(ObjectAssociation, gDeepCopy, ObjectAssociation_im_gDeepCopy);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return ObjectAssociation_c;
}



