/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0




#define	CLASS	ObjectPool_c
#define	ivType	ObjectPool_iv_t

#include "generics.h"

object	ObjectPool_c;


#line 48 "ObjectPool.c"
typedef struct  _ObjectPool_iv_t  {
	object iObjects;
}	ObjectPool_iv_t;


#line 54 "ObjectPool.c"
typedef struct  _ObjectPool_cv_t  {
	object cPools;
	object cCurrentPool;
}	ObjectPool_cv_t;

static	ObjectPool_cv_t	*ObjectPool_cv;


#line 38 "ObjectPool.d"
#define DFLT_SIZE 201 


PMETHOD objrtn init(object self, int siz)
{ ObjectPool_iv_t *iv = GetIVs(ObjectPool, self);
	iv->iObjects = gNewWithInt(Dictionary, siz); 
	return self; 
} 

cmeth objrtn ObjectPool_cm_gNew(object self)
{ 
	return init(oSuper(ObjectPool_c, gNew, self)(self), DFLT_SIZE); 
} 

cmeth objrtn ObjectPool_cm_gNewWithInt(object self, int siz)
{ 
	return init(oSuper(ObjectPool_c, gNew, self)(self), siz); 
} 

cmeth objrtn ObjectPool_cm_gNewGlobalPool(object self)
{ 
	return gNewGlobalPoolWithSize(self, DFLT_SIZE); 
} 

cmeth objrtn ObjectPool_cm_gNewGlobalPoolWithSize(object self, int siz)
{ 
	if (ObjectPool_cv->cCurrentPool) { 
		if (!ObjectPool_cv->cPools) 
			ObjectPool_cv->cPools = gNew(LinkObject); 
		gAddFirst(ObjectPool_cv->cPools, ObjectPool_cv->cCurrentPool); 
	} 
	return ObjectPool_cv->cCurrentPool = gNewWithInt(self, siz); 
} 

imeth objrtn ObjectPool_im_gDispose(object self)
{ ObjectPool_iv_t *iv = GetIVs(ObjectPool, self);
	object ass; 

	while (ass = gFirst(iv->iObjects)) 
		gDisposeObject(self, (object) gPointerValue(gKey(ass))); 
	gDeepDispose(iv->iObjects); 
	return oSuper(ObjectPool_c, gDispose, self)(self); 
} 

cmeth objrtn ObjectPool_cm_gDisposeGlobalPool(object self)
{ 
	if (ObjectPool_cv->cCurrentPool) { 
		ObjectPool_cv->cCurrentPool = gDispose(ObjectPool_cv->cCurrentPool); 
		if (ObjectPool_cv->cPools && gSize(ObjectPool_cv->cPools)) 
			ObjectPool_cv->cCurrentPool = gPop(ObjectPool_cv->cPools); 
	} 
	return ObjectPool_cv->cCurrentPool; 
} 

imeth objrtn ObjectPool_im_gAddToPool(object self, int deepFlag, object obj)
{ ObjectPool_iv_t *iv = GetIVs(ObjectPool, self);
	object val = gNewWithObjObj(ObjectAssociation, gNewWithInt(ShortInteger, deepFlag), gNewWithLong(LongInteger, gObjectSerialNumber(obj))); 
	object pobj = gNewWithPtr(Pointer, obj); 
	if (!gAddValue(iv->iObjects, pobj, val)) { 
		gDeepDisposeObj(iv->iObjects, pobj); 
		gAddValue(iv->iObjects, pobj, val); 
	} 
	return obj; 
} 

cmeth objrtn ObjectPool_cm_gAddToPool(object self, int deepFlag, object obj)
{ 
	return gAddToPool(ObjectPool_cv->cCurrentPool, deepFlag, obj); 
} 

imeth objrtn ObjectPool_im_gDisposeObject(object self, object obj)
{ ObjectPool_iv_t *iv = GetIVs(ObjectPool, self);
	object pobj = gNewWithPtr(Pointer, obj); 
	object val = gFindValue(iv->iObjects, pobj); 
	if (val) { 
		if (IsObj(obj)) { 
			long v1 = gObjectSerialNumber(obj); 
			long v2 = gLongValue(gValue(val)); 
			if (v1 == v2) 
				gShortValue(gKey(val)) ? gDeepDispose(obj) : gDispose(obj); 
		} 
		gDeepDisposeObj(iv->iObjects, pobj); 
	} 
	gDispose(pobj); 
	return NULL; 
} 

cmeth objrtn ObjectPool_cm_gDisposeObject(object self, object obj)
{ 
	return gDisposeObject(ObjectPool_cv->cCurrentPool, obj); 
} 

imeth objrtn ObjectPool_im_gRemoveFromPool(object self, object obj)
{ ObjectPool_iv_t *iv = GetIVs(ObjectPool, self);
	object pobj = gNewWithPtr(Pointer, obj); 
	gDeepDisposeObj(iv->iObjects, pobj); 
	gDispose(pobj); 
	return obj; 
} 

cmeth objrtn ObjectPool_cm_gRemoveFromPool(object self, object obj)
{ 
	return gRemoveFromPool(ObjectPool_cv->cCurrentPool, obj); 
} 

#line 169 "ObjectPool.c"

objrtn	ObjectPool_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (ObjectPool_c) {
		LEAVECRITICALSECTION(cs);
		return ObjectPool_c;
	}
	INHIBIT_THREADER;
	ObjectPool_c = gNewClass(Class, "ObjectPool", sizeof(ObjectPool_iv_t), sizeof(ObjectPool_cv_t), END);
	cMethodFor(ObjectPool, gNewGlobalPoolWithSize, ObjectPool_cm_gNewGlobalPoolWithSize);
	cMethodFor(ObjectPool, gDisposeGlobalPool, ObjectPool_cm_gDisposeGlobalPool);
	cMethodFor(ObjectPool, gRemoveFromPool, ObjectPool_cm_gRemoveFromPool);
	cMethodFor(ObjectPool, gNewWithInt, ObjectPool_cm_gNewWithInt);
	cMethodFor(ObjectPool, gAddToPool, ObjectPool_cm_gAddToPool);
	cMethodFor(ObjectPool, gNew, ObjectPool_cm_gNew);
	cMethodFor(ObjectPool, gNewGlobalPool, ObjectPool_cm_gNewGlobalPool);
	cMethodFor(ObjectPool, gDisposeObject, ObjectPool_cm_gDisposeObject);
	iMethodFor(ObjectPool, gRemoveFromPool, ObjectPool_im_gRemoveFromPool);
	iMethodFor(ObjectPool, gAddToPool, ObjectPool_im_gAddToPool);
	iMethodFor(ObjectPool, gDispose, ObjectPool_im_gDispose);
	iMethodFor(ObjectPool, gDeepDispose, ObjectPool_im_gDispose);
	iMethodFor(ObjectPool, gDisposeObject, ObjectPool_im_gDisposeObject);

	ObjectPool_cv = GetCVs(ObjectPool);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return ObjectPool_c;
}



