/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 33 "SetSequence.d"
#include "set1.h" 

#define	CLASS	SetSequence_c
#define	ivType	SetSequence_iv_t

#include "generics.h"

object	SetSequence_c;


#line 50 "SetSequence.c"
typedef struct  _SetSequence_iv_t  {
	int iTabidx;
	int iSize;
	NODE * iTab;
	NODE iCurrent;
}	SetSequence_iv_t;



#line 43 "SetSequence.d"
cmeth objrtn SetSequence_cm_gNewSetSeq(object self, int size, int nelm, void *tab)
{ 
	object seq = oSuper(SetSequence_c, gNew, self)(self); 
	ivType *iv = ivPtr(seq); 
	iv->iSize = size; 
	iv->iTab = (NODE *) tab; 
	if (nelm) { 
		for (; !iv->iTab[iv->iTabidx] ; ++iv->iTabidx); 
		iv->iCurrent = iv->iTab[iv->iTabidx]; 
	} 
	return seq; 
} 

imeth objrtn SetSequence_im_gNext(object self)
{ SetSequence_iv_t *iv = GetIVs(SetSequence, self);
	NODE n; 
	if (n = iv->iCurrent) { 
		if (!(iv->iCurrent = iv->iCurrent->next)) 
			while (++iv->iTabidx < iv->iSize) 
			if (iv->iTab[iv->iTabidx]) { 
			iv->iCurrent = iv->iTab[iv->iTabidx]; 
			break; 
		} 
		return n->luk; 
	} 
	return gDispose(self); 
} 


#line 90 "SetSequence.c"

objrtn	SetSequence_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (SetSequence_c) {
		LEAVECRITICALSECTION(cs);
		return SetSequence_c;
	}
	INHIBIT_THREADER;
	Sequence_initialize();
	if (SetSequence_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return SetSequence_c;
	}
	SetSequence_c = gNewClass(Class, "SetSequence", sizeof(SetSequence_iv_t), 0, Sequence, END);
	cMethodFor(SetSequence, gNewSetSeq, SetSequence_cm_gNewSetSeq);
	iMethodFor(SetSequence, gNext, SetSequence_im_gNext);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return SetSequence_c;
}



