/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 32 "ShortInteger.d"
#include <math.h> 

#define	CLASS	ShortInteger_c
#define	ivType	ShortInteger_iv_t

#include "generics.h"

object	ShortInteger_c;


#line 50 "ShortInteger.c"
typedef struct  _ShortInteger_iv_t  {
	short int iVal;
}	ShortInteger_iv_t;



#line 38 "ShortInteger.d"
cmeth objrtn ShortInteger_cm_gNewWithInt(object self, int val)
{ 
	object obj = oSuper(ShortInteger_c, gNew, self)(self); 
	ivType *iv = ivPtr(obj); 
	iv->iVal = (short int) val; 
	return(obj); 
} 

imeth int ShortInteger_im_gHash(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	double t; 

	t = .6125423371 * (unsigned) iv->iVal; 
	t = t < 0.0 ? -t : t; 
	return (int) (BIG_INT * (t - floor(t))); 
} 

imeth int ShortInteger_im_gCompare(object self, object obj)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	short sv, ov; 

	ChkArg(obj, 2); 
	if (ClassOf(obj) != CLASS) 
		return oSuper(ShortInteger_c, gCompare, self)(self, obj); 
	if ((sv=iv->iVal) < (ov=ivPtr(obj)->iVal)) 
		return -1; 
	else if (sv == ov) 
		return 0; 
	else 
		return 1; 
} 

imeth objrtn ShortInteger_im_gStringRepValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return vSprintf(String, "%hd", iv->iVal); 
} 

imeth char ShortInteger_im_gCharValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return (char) iv->iVal; 
} 

imeth short ShortInteger_im_gShortValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return (short) iv->iVal; 
} 

imeth unsigned short ShortInteger_im_gUnsignedShortValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return (unsigned short) iv->iVal; 
} 

imeth long ShortInteger_im_gLongValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return (long) iv->iVal; 
} 

imeth double ShortInteger_im_gDoubleValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return (double) iv->iVal; 
} 

imeth void * ShortInteger_im_gPointerValue(object self)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	return (void *) &iv->iVal; 
} 

imeth objrtn ShortInteger_im_gChangeValue(object self, object val)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	ChkArg(val, 2); 
	iv->iVal = gShortValue(val); 
	return self; 
} 

imeth objrtn ShortInteger_im_gChangeCharValue(object self, int val)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	iv->iVal = (short) val; 
	return self; 
} 

imeth objrtn ShortInteger_im_gChangeShortValue(object self, int val)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	iv->iVal = (short) val; 
	return self; 
} 

imeth objrtn ShortInteger_im_gChangeUShortValue(object self, unsigned val)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	iv->iVal = (short) val; 
	return self; 
} 

imeth objrtn ShortInteger_im_gChangeLongValue(object self, long val)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	iv->iVal = (short) val; 
	return self; 
} 

imeth objrtn ShortInteger_im_gChangeDoubleValue(object self, double val)
{ ShortInteger_iv_t *iv = GetIVs(ShortInteger, self);
	iv->iVal = (short) val; 
	return self; 
} 


#line 163 "ShortInteger.c"

objrtn	ShortInteger_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (ShortInteger_c) {
		LEAVECRITICALSECTION(cs);
		return ShortInteger_c;
	}
	INHIBIT_THREADER;
	Number_initialize();
	if (ShortInteger_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return ShortInteger_c;
	}
	ShortInteger_c = gNewClass(Class, "ShortInteger", sizeof(ShortInteger_iv_t), 0, Number, END);
	cMethodFor(ShortInteger, gNewWithInt, ShortInteger_cm_gNewWithInt);
	iMethodFor(ShortInteger, gUnsignedShortValue, ShortInteger_im_gUnsignedShortValue);
	iMethodFor(ShortInteger, gChangeDoubleValue, ShortInteger_im_gChangeDoubleValue);
	iMethodFor(ShortInteger, gDoubleValue, ShortInteger_im_gDoubleValue);
	iMethodFor(ShortInteger, gCompare, ShortInteger_im_gCompare);
	iMethodFor(ShortInteger, gChangeLongValue, ShortInteger_im_gChangeLongValue);
	iMethodFor(ShortInteger, gChangeShortValue, ShortInteger_im_gChangeShortValue);
	iMethodFor(ShortInteger, gShortValue, ShortInteger_im_gShortValue);
	iMethodFor(ShortInteger, gPointerValue, ShortInteger_im_gPointerValue);
	iMethodFor(ShortInteger, gCharValue, ShortInteger_im_gCharValue);
	iMethodFor(ShortInteger, gStringRepValue, ShortInteger_im_gStringRepValue);
	iMethodFor(ShortInteger, gChangeUShortValue, ShortInteger_im_gChangeUShortValue);
	iMethodFor(ShortInteger, gHash, ShortInteger_im_gHash);
	iMethodFor(ShortInteger, gChangeValue, ShortInteger_im_gChangeValue);
	iMethodFor(ShortInteger, gLongValue, ShortInteger_im_gLongValue);
	iMethodFor(ShortInteger, gChangeCharValue, ShortInteger_im_gChangeCharValue);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return ShortInteger_c;
}



