/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0




#define	CLASS	Stream_c
#define	ivType	Stream_iv_t

#include "generics.h"

object	Stream_c;


#line 37 "Stream.d"
#include <string.h> 


object stdoutStream_o, stdinStream_o, stderrStream_o, traceStream_o; 


imeth int Stream_im_gPuts(object self, char *str)
{ 
	if (IsObj((object)str)) 
		str = gStringValue((object)str); 
	return gWrite(self, str, strlen(str)); 
} 

imeth int Stream_im_gPutc(object self, int i)
{ 
	char c = (char) i; 
	return 1 == (gWrite(self, &c, 1)) ? i : EOF; 
} 

ivmeth int Stream_ivm_vPrintf(object self, va_list _rest_)
{ char * fmt = va_arg(_rest_, char *);
	char buf[1024]; 
	MAKE_REST(fmt); 

	buf[1020] = 'E'; 
	buf[1021] = 'O'; 
	buf[1022] = 'S'; 
	buf[1023] = '\0'; 
	vsprintf(buf, fmt, _rest_); 
	if (buf[1020] != 'E' || 
		buf[1021] != 'O' || 
		buf[1022] != 'S' || 
		buf[1023]) 
		gError(Object, "vPrintf buffer overflow"); 
	return gWrite(self, buf, strlen(buf)); 
} 

#line 86 "Stream.c"

static	int	Stream_ifm_vPrintf(object self, ...)
{
	va_list	_rest_;
	va_start(_rest_, self);
	return Stream_ivm_vPrintf(self, _rest_);
}



#line 74 "Stream.d"
imeth objrtn Stream_im_gCopy(object self)
{ 
	return gShouldNotImplement(self, "Copy/DeepCopy"); 
} 

static void class_init(void) 
{ 
	Dynace; 
	RegisterVariable(stdoutStream_o); 
	RegisterVariable(stderrStream_o); 
	RegisterVariable(stdinStream_o); 
	RegisterVariable(traceStream_o); 
} 

#line 112 "Stream.c"

objrtn	Stream_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (Stream_c) {
		LEAVECRITICALSECTION(cs);
		return Stream_c;
	}
	INHIBIT_THREADER;
	Stream_c = gNewClass(Class, "Stream", 0, 0, END);
	iMethodFor(Stream, gPuts, Stream_im_gPuts);
	ivMethodFor(Stream, vPrintf, Stream_ivm_vPrintf, Stream_ifm_vPrintf);
	iMethodFor(Stream, gPutc, Stream_im_gPutc);
	iMethodFor(Stream, gCopy, Stream_im_gCopy);
	iMethodFor(Stream, gDeepCopy, Stream_im_gCopy);

	class_init();

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return Stream_c;
}



