/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 32 "StringAssociation.d"
#include <string.h> 
#include <math.h> 
#include "memalloc.h" 

#define	CLASS	StringAssociation_c
#define	ivType	StringAssociation_iv_t

#include "generics.h"

object	StringAssociation_c;


#line 52 "StringAssociation.c"
typedef struct  _StringAssociation_iv_t  {
	object iKey;
	char * iKeysp;
	object iValue;
}	StringAssociation_iv_t;



#line 43 "StringAssociation.d"
PMETHOD objrtn init(object self, char *key, object val)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	iv->iKey = gNewWithStr(String, key); 
	iv->iKeysp = gStringValue(iv->iKey); 
	iv->iValue = val; 
	return self; 
} 

cmeth objrtn StringAssociation_cm_gNewWithStrObj(object self, char *key, object val)
{ 
	return init(oSuper(StringAssociation_c, gNew, self)(self), key, val); 
} 

imeth objrtn StringAssociation_im_gDeepCopy(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	return gNewWithStrObj(CLASS, iv->iKeysp, iv->iValue?gDeepCopy(iv->iValue):NULL); 
} 

imeth objrtn StringAssociation_im_gCopy(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	return gNewWithStrObj(CLASS, iv->iKeysp, iv->iValue); 
} 

imeth objrtn StringAssociation_im_gKey(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	return iv->iKey; 
} 

imeth objrtn StringAssociation_im_gValue(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	return iv->iValue; 
} 

imeth objrtn StringAssociation_im_gChangeValue(object self, object value)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	object ret; 
	ChkArgNul(value, 2); 
	ret = iv->iValue; 
	iv->iValue = value; 
	return ret; 
} 

imeth char * StringAssociation_im_gStringKey(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	return iv->iKeysp; 
} 

imeth objrtn StringAssociation_im_gChangeStringKey(object self, char *key)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	gDispose(iv->iKey); 
	iv->iKey = gNewWithStr(String, key); 
	iv->iKeysp = gStringValue(iv->iKey); 
	return self; 
} 

imeth objrtn StringAssociation_im_gDispose(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	gDispose(iv->iKey); 
	return oSuper(StringAssociation_c, gDispose, self)(self); 
} 

imeth objrtn StringAssociation_im_gDeepDispose(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	gDispose(iv->iKey); 
	if (iv->iValue) 
		gDeepDispose(iv->iValue); 
	return oSuper(StringAssociation_c, gDeepDispose, self)(self); 
} 

imeth objrtn StringAssociation_im_gStringRepValue(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	object s, t; 

	t = iv->iValue ? gStringRepValue(iv->iValue) : (object) NULL; 
	s = vSprintf(String, "( \"%s\", ", iv->iKeysp ? iv->iKeysp : "(null)"); 
	vBuild(s, NULL, t ? (char *) t : "(null)", " )", NULL); 
	if (t) 
		gDispose(t); 
	return s; 
} 

imeth int StringAssociation_im_gHash(object self)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	register char c = 'a'; 
	char *s = iv->iKeysp; 
	double t; 
	register unsigned short k=0; 

	if (s) 
		while (*s) 
		k += *s++ ^ c++; 
	t = .6125423371 * k; 
	t = t < 0.0 ? -t : t; 
	return (int) (BIG_INT * (t - floor(t))); 
} 

imeth int StringAssociation_im_gCompare(object self, object arg)
{ StringAssociation_iv_t *iv = GetIVs(StringAssociation, self);
	ChkArg(arg, 2); 
	return strcmp(iv->iKeysp?iv->iKeysp:"", gStringKey(arg)); 
} 


#line 165 "StringAssociation.c"

objrtn	StringAssociation_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (StringAssociation_c) {
		LEAVECRITICALSECTION(cs);
		return StringAssociation_c;
	}
	INHIBIT_THREADER;
	Association_initialize();
	if (StringAssociation_c)  {
		ENABLE_THREADER;
		LEAVECRITICALSECTION(cs);
		return StringAssociation_c;
	}
	StringAssociation_c = gNewClass(Class, "StringAssociation", sizeof(StringAssociation_iv_t), 0, Association, END);
	cMethodFor(StringAssociation, gNewWithStrObj, StringAssociation_cm_gNewWithStrObj);
	iMethodFor(StringAssociation, gCompare, StringAssociation_im_gCompare);
	iMethodFor(StringAssociation, gKey, StringAssociation_im_gKey);
	iMethodFor(StringAssociation, gStringKey, StringAssociation_im_gStringKey);
	iMethodFor(StringAssociation, gDispose, StringAssociation_im_gDispose);
	iMethodFor(StringAssociation, gChangeStringKey, StringAssociation_im_gChangeStringKey);
	iMethodFor(StringAssociation, gValue, StringAssociation_im_gValue);
	iMethodFor(StringAssociation, gStringRepValue, StringAssociation_im_gStringRepValue);
	iMethodFor(StringAssociation, gHash, StringAssociation_im_gHash);
	iMethodFor(StringAssociation, gChangeValue, StringAssociation_im_gChangeValue);
	iMethodFor(StringAssociation, gCopy, StringAssociation_im_gCopy);
	iMethodFor(StringAssociation, gDeepDispose, StringAssociation_im_gDeepDispose);
	iMethodFor(StringAssociation, gDeepCopy, StringAssociation_im_gDeepCopy);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return StringAssociation_c;
}



