/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 32 "WeakPointer.d"
#include <math.h> 
#include <stdint.h> 

#define	CLASS	WeakPointer_c
#define	ivType	WeakPointer_iv_t

#include "generics.h"

object	WeakPointer_c;


#line 51 "WeakPointer.c"
typedef struct  _WeakPointer_iv_t  {
	object iVal;
	long iObjSN;
}	WeakPointer_iv_t;



#line 40 "WeakPointer.d"
PMETHOD objrtn init(object self, object obj)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	iv->iVal = obj; 
	if (IsObj(obj)) 
		iv->iObjSN = gObjectSerialNumber(obj); 
	return self; 
} 

cmeth objrtn WeakPointer_cm_gNewWithPtr(object self, void *val)
{ 
	return init(oSuper(WeakPointer_c, gNew, self)(self), (object) val); 
} 

cmeth objrtn WeakPointer_cm_gNewWithObj(object self, object val)
{ 
	return init(oSuper(WeakPointer_c, gNew, self)(self), val); 
} 

imeth objrtn WeakPointer_im_gDeepDispose(object self)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	if (iv->iVal && iv->iObjSN && IsObj(iv->iVal) && gObjectSerialNumber(iv->iVal) == iv->iObjSN) 
		gDeepDispose(iv->iVal); 
	return oSuper(WeakPointer_c, gDeepDispose, self)(self); 
} 

imeth void * WeakPointer_im_gPointerValue(object self)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	if (iv->iObjSN && (!IsObj(iv->iVal) || gObjectSerialNumber(iv->iVal) != iv->iObjSN)) { 
		iv->iVal = NULL; 
		iv->iObjSN = 0; 
	} 
	return (void *) iv->iVal; 
} 

imeth objrtn WeakPointer_im_gValue(object self)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	if (iv->iObjSN && (!IsObj(iv->iVal) || gObjectSerialNumber(iv->iVal) != iv->iObjSN)) { 
		iv->iVal = NULL; 
		iv->iObjSN = 0; 
	} 
	return iv->iVal; 
} 

imeth objrtn WeakPointer_im_gChangeValue(object self, object val)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	iv->iObjSN = IsObj(val) ? gObjectSerialNumber(val) : 0; 
	iv->iVal = val; 
	return self; 
} 

imeth int WeakPointer_im_gHash(object self)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	double t; 

	t = .6125423371 * (double) (intptr_t) iv->iVal; 
	t = t < 0.0 ? -t : t; 
	return (int) (BIG_INT * (t - floor(t))); 
} 

imeth int WeakPointer_im_gCompare(object self, object obj)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	void *sv, *ov; 

	ChkArg(obj, 2); 
	if (ClassOf(obj) != CLASS) 
		return oSuper(WeakPointer_c, gCompare, self)(self, obj); 
	if ((sv=iv->iVal) < (ov=ivPtr(obj)->iVal)) 
		return -1; 
	else if (sv == ov) 
		return 0; 
	else 
		return 1; 
} 

imeth objrtn WeakPointer_im_gStringRepValue(object self)
{ WeakPointer_iv_t *iv = GetIVs(WeakPointer, self);
	return vSprintf(String, "%lp", iv->iVal); 
} 


#line 140 "WeakPointer.c"

objrtn	WeakPointer_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (WeakPointer_c) {
		LEAVECRITICALSECTION(cs);
		return WeakPointer_c;
	}
	INHIBIT_THREADER;
	WeakPointer_c = gNewClass(Class, "WeakPointer", sizeof(WeakPointer_iv_t), 0, END);
	cMethodFor(WeakPointer, gNewWithObj, WeakPointer_cm_gNewWithObj);
	cMethodFor(WeakPointer, gNewWithPtr, WeakPointer_cm_gNewWithPtr);
	iMethodFor(WeakPointer, gCompare, WeakPointer_im_gCompare);
	iMethodFor(WeakPointer, gPointerValue, WeakPointer_im_gPointerValue);
	iMethodFor(WeakPointer, gValue, WeakPointer_im_gValue);
	iMethodFor(WeakPointer, gStringRepValue, WeakPointer_im_gStringRepValue);
	iMethodFor(WeakPointer, gHash, WeakPointer_im_gHash);
	iMethodFor(WeakPointer, gChangeValue, WeakPointer_im_gChangeValue);
	iMethodFor(WeakPointer, gDeepDispose, WeakPointer_im_gDeepDispose);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return WeakPointer_c;
}



