/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/



/*  This file automatically generated by dpp - do not edit  */

#define	DPP_STRATEGY	2
#define	DPP_FASTWIDE	0



#line 31 "InputStream.d"
#include <ctype.h> 
#include <string.h> 

#include "dpp.h" 

#define MAXBUF 4096 
#define MAXWORDSZ 256 


#define istart2(x) (isalpha(x) || (x) == '_' || (x) == '#') 


#ifdef unix 
#define RMODE "r" 
#define WMODE "w" 
#else 


#line 47 "InputStream.d"
#define RMODE "rt" 
#define WMODE "wt" 
#endif 


#define	CLASS	InputStream_c
#define	ivType	InputStream_iv_t

#include "generics.h"

object	InputStream_c;


#line 72 "InputStream.c"
typedef struct  _InputStream_iv_t  {
	object iStream;
	long iLine;
	char * iBuf;
	char * iPtr;
}	InputStream_iv_t;


#line 59 "InputStream.d"
extern objrtn open_file(char *file,char *mode, int real_quiet); 


cmeth objrtn InputStream_cm_gNew(object self)
{ 
	return gShouldNotImplement(self, "gNew"); 
} 

cmeth objrtn InputStream_cm_gNewWithStr(object self, char *file)
{ 
	object s, obj; 
	ivType *iv; 

	s = open_file(file, RMODE, 0); 
	if (!s) 
		return NULL; 
	obj = oSuper(InputStream_c, gNew, self)(self); 
	iv = ivPtr(obj); 
	iv->iStream = s; 
	iv->iBuf = Tnalloc(char, MAXBUF); 
	*iv->iBuf = '\0'; 
	iv->iPtr = iv->iBuf; 
	return obj; 
} 

imeth objrtn InputStream_im_gDispose(object self)
{ InputStream_iv_t *iv = GetIVs(InputStream, self);
	gDispose(iv->iStream); 
	free(iv->iBuf); 
	return oSuper(InputStream_c, gDispose, self)(self); 
} 

imeth objrtn InputStream_im_gGCDispose(object self)
{ InputStream_iv_t *iv = GetIVs(InputStream, self);
	free(iv->iBuf); 
	return oSuper(InputStream_c, gGCDispose, self)(self); 
} 



static int get_line(ivType *iv) 
{ 
	char *tbuf; 
	int something = 0, i; 

	tbuf = iv->iBuf; 
	*tbuf = '\0'; 
	while (1) { 
		if (!gGets(iv->iStream, tbuf, MAXBUF-(int)strlen(iv->iBuf))) 
			break; 
		iv->iLine++; 
		something = 1; 
		i = (int)strlen(tbuf) - 1; 
		while (i >= 0 && (tbuf[i] == '\n' || tbuf[i] == '\r')) 
			i--; 
		if (i < 0 || tbuf[i] != '\\') { 
			tbuf[i+1] = '\0'; 
			break; 
		} 
		tbuf[i] = '\0'; 
		tbuf += i; 
	} 
	return something; 
} 


#define IS(a, b) *iv->iPtr == a && iv->iPtr[1] == b 
#define IS3(a, b, c) *iv->iPtr == a && iv->iPtr[1] == b && iv->iPtr[2] == c 

#define CODE_STATE 1 
#define COMMENT_STATE 2 



static int next_token(ivType *iv) 
{ 
	int state = CODE_STATE; 

	while (1) { 
		if (!*iv->iPtr) 
			if (get_line(iv)) 
			iv->iPtr = iv->iBuf; 
		else 
			return 0; 
		else if (state == CODE_STATE) { 
			if (isspace(*iv->iPtr)) 
				iv->iPtr++; 
			else if (IS('/', '/')) 
				*iv->iPtr = '\0'; 
			else if (IS('/', '*')) { 
				state = COMMENT_STATE; 
				iv->iPtr += 2; 
			} else 
				return 1; 
		} else { 
			if (IS('*', '/')) { 
				iv->iPtr += 2; 
				state = CODE_STATE; 
			} else 
				iv->iPtr++; 
		} 
	} 

} 

imeth int InputStream_im_gLineHasColon(object self)
{ InputStream_iv_t *iv = GetIVs(InputStream, self);
	char *p = iv->iPtr; 

	while (*p) 
		if (*p++ == ':') 
		return 1; 
	return 0; 
} 

imeth objrtn InputStream_im_gNextToken(object self)
{ InputStream_iv_t *iv = GetIVs(InputStream, self);
	char *w, token[MAXWORDSZ]; 
	int i; 

	if (!next_token(iv)) 
		return NULL; 
	w = token; 
	if (istart2(*iv->iPtr)) { 
		*w++ = *iv->iPtr++; 
		for (i=0 ; ++i <= MAXWORDSZ && irest(*iv->iPtr) ;) 
			*w++ = *iv->iPtr++; 
	} else 
		if (IS3('<', '<', '=') || 
		IS3('>', '>', '=') || 
		IS3(':', ':', '*') || 
		IS3('-', '>', '*') || 
		IS3('.', '.', '.')) { 
		*w++ = *iv->iPtr++; 
		*w++ = *iv->iPtr++; 
		*w++ = *iv->iPtr++; 
	} else if (IS('*', '=') || 
		IS('/', '=') || 
		IS('%', '=') || 
		IS('+', '=') || 
		IS('-', '=') || 
		IS('&', '=') || 
		IS('^', '=') || 
		IS('|', '=') || 
		IS('&', '&') || 
		IS('|', '|') || 
		IS('=', '=') || 
		IS('!', '=') || 
		IS('<', '<') || 
		IS('>', '>') || 
		IS('<', '=') || 
		IS('>', '=') || 
		IS('-', '-') || 
		IS('+', '+') || 
		IS(':', ':') || 
		IS('.', '*') || 
		IS('-', '>')) { 
		*w++ = *iv->iPtr++; 
		*w++ = *iv->iPtr++; 
	} else if (*iv->iPtr == '"' || *iv->iPtr == '\'') { 
		char type = *iv->iPtr; 
		*w++ = *iv->iPtr++; 
		while (*iv->iPtr && *iv->iPtr != type) { 
			*w++ = *iv->iPtr; 
			if (*iv->iPtr == '\\' && iv->iPtr[1]) 
				*w++ = *++iv->iPtr; 
			++iv->iPtr; 
		} 
		if (*iv->iPtr) 
			*w++ = *iv->iPtr++; 
	} else if (isdigit(*iv->iPtr) || *iv->iPtr == '.' && isdigit(iv->iPtr[1])) { 
		int hex; 

		if (hex = (*iv->iPtr == '0' && (iv->iPtr[1] == 'x' || iv->iPtr[1] == 'X'))) { 
			*w++ = *iv->iPtr++; 
			*w++ = *iv->iPtr++; 
		} 
		while ((hex ? isxdigit(*iv->iPtr) : isdigit(*iv->iPtr)) || *iv->iPtr == '.' || *iv->iPtr == 'e' || *iv->iPtr == 'E' 
			|| ((*iv->iPtr=='-' || *iv->iPtr=='+') && 
			(iv->iPtr[-1] == 'e' || iv->iPtr[-1] == 'E')) ) 
			*w++ = *iv->iPtr++; 
		if (*iv->iPtr == 'u' || *iv->iPtr == 'U' || *iv->iPtr == 'l' || *iv->iPtr == 'L') 
			*w++ = *iv->iPtr++; 
		if (*iv->iPtr == 'u' || *iv->iPtr == 'U' || *iv->iPtr == 'l' || *iv->iPtr == 'L') 
			*w++ = *iv->iPtr++; 
	} else 
		*w++ = *iv->iPtr++; 
	*w = '\0'; 

	i = isspace(*iv->iPtr) || !*iv->iPtr || 
		iv->iPtr[0] == '/' && iv->iPtr[1] == '*' || 
		iv->iPtr[0] == '/' && iv->iPtr[1] == '/'; 
	return gNewToken(Token, token, iv->iLine, i); 
} 


#line 278 "InputStream.c"

objrtn	InputStream_initialize(void)
{
	static  CRITICALSECTION  cs;
	static  int volatile once = 0;

	ENTERCRITICALSECTION(_CI_CS_);
	if (!once) {
		INITIALIZECRITICALSECTION(cs);
		once = 1;
	}
	LEAVECRITICALSECTION(_CI_CS_);

	ENTERCRITICALSECTION(cs);

	if (InputStream_c) {
		LEAVECRITICALSECTION(cs);
		return InputStream_c;
	}
	INHIBIT_THREADER;
	InputStream_c = gNewClass(Class, "InputStream", sizeof(InputStream_iv_t), 0, END);
	cMethodFor(InputStream, gNewWithStr, InputStream_cm_gNewWithStr);
	cMethodFor(InputStream, gNew, InputStream_cm_gNew);
	iMethodFor(InputStream, gDispose, InputStream_im_gDispose);
	iMethodFor(InputStream, gGCDispose, InputStream_im_gGCDispose);
	iMethodFor(InputStream, gLineHasColon, InputStream_im_gLineHasColon);
	iMethodFor(InputStream, gNextToken, InputStream_im_gNextToken);
	iMethodFor(InputStream, gDeepDispose, InputStream_im_gDispose);

	ENABLE_THREADER;

	LEAVECRITICALSECTION(cs);

	return InputStream_c;
}



