/*
  Copyright (c) 1996 Blake McBride
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

  1. Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#include "generics.h"

#define	MEMU  \
  printf("Memory usage %ld, %ld\n", gMaxMemUsed(Dynace), gCurMemUsed(Dynace)) 


main(int argc, char *argv[])
{
	object	obj;
	long	n, mba, cmu;

	InitClasses(&argc);


	/*  The following line is used to turn on the automatic garbage
	    collector (un-comment after the first run) */

//	gSetMemoryBufferArea(Dynace, 50000L); 



	/*  Create enough new objects to fill up all the memory of a PC
	    (since no objects are ever explictly disposed).  */

	MEMU;
	for (n=0 ; n++ != 125000L ; )  {
		if (!(n % 1000L))
			printf("%ld\n", n);
		obj = vNew(DoubleFloat, 3.141);
	}
	gPrint(obj, stdoutStream);
	gGC(Dynace);
	MEMU;
	gPrint(obj, stdoutStream);
	       
	getch();
	
	return 0;
}


